//+----------------------------------------------------------------------+
//|    Multiple Indicator EA                           mi_v7.mq4         |
//|                                              Copyright  2005        |
//|    Thanks to Starter for the order entry routines.                   |
//|    Special thanks to MrPip in his extensive help in the programming  |
//|    effort.                                                           |
//+----------------------------------------------------------------------+
#property copyright "Copyright  2005, Strategybuilderfx members"
#property link      "http:/strategybuilderfx.com/"
#include <stdlib.mqh>

extern bool Debug=true;                 // Change to true to allow print.
extern bool Debug1=false;                 // Change to true to allow print.

//+---------------------------------------------------+
//|Account functions                                  |
//+---------------------------------------------------+

extern bool AccountIsMini = false;       // Change to true if trading mini account.

//+---------------------------------------------------+
//|Money Management                                   |
//+---------------------------------------------------+

extern bool MoneyManagement = false;   // Change to false if you want to shutdown money management controls.
                                     // Lots = 1 will be in effect and only 1 lot will be open regardless of equity.
extern double Riskpercent = 10;     // Change to whatever percent of equity you wish to risk.
extern double DecreaseFactor = 3;   // Used to decrease lot size after a loss is experienced to protect equity.  Recommended not to change.
extern double StopLoss = 35;        // Maximum pips willing to lose per position.
extern double TrailingStop = 0;     // Change to whatever number of pips you wish to trail your position with.
extern int MaximumLosses = 3;       // Maximum number of losses per day willing to experience.
extern double Margincutoff = 800;   // Expert will stop trading if equity level decreases to that level.

//+---------------------------------------------------+
//|Profit controls                                    |
//+---------------------------------------------------+

extern int TakeProfit = 0;         // Maximum profit level achieved.    
extern double Stop = 0;             // Minimum profit level achieved and usually achieved target.
extern int Slippage = 10;           // Possible fix for not getting filled or closed    

//+---------------------------------------------------+
//|Indicator Variables                                |
//+---------------------------------------------------+

extern double MA1PeriodEntry=4;                   // Moving average period 1.
extern double MA2PeriodEntry=21;                  // Moving average period 2.
extern double MA3PeriodEntry=34;                 // Moving average period 3. 
//extern double MA4PeriodEntry=16;                   // Moving average period 4.
//extern double MA5PeriodEntry=21;                   // Moving average period 5.
extern double MA11PeriodExit=4;                    // Moving average period 11. Possibly use for exit condition.
extern double MA12PeriodExit=21;                  // Moving average period 12. Possibly use for exit condition.
extern double MA13PeriodExit=34;                  // Moving average period 13. Possibly use for exit condition.
//extern double MA14PeriodExit=16;                   // Moving average period 14. Possibly use for exit condition.
//extern double MA15PeriodExit=21;                   // Moving average period 15. Possibly use for exit condition.
extern double MA1PeriodAngle=89;                   // Moving angle period for market direction check.
// Input Parameters for Juice
extern bool UseJuice=true;
extern bool TestStochAngle=false;                 // Test if stochastics indicator is rising or falling.
extern double StochKPeriod=13;                     // Stochastic period %K.
extern double StochDPeriod=8;                     // Stochastic period %D.
extern double StochSlowing=8;                     // Stochastic slowing.
extern bool TestBollingerWidth=false;             // Tests for standard deviation width.
extern double BollingerPeriod1=5;                 // Bollinger band period 1.
extern double BollingerStdDev1=3;                 // Bollinger band standard deviation period 1.
//extern bool TestBollingerHighExit=false;          // Tests for wide spread of Bollinger band during spikes that affect other exit conditions.
extern double BollingerWidthLow=20;               // Bollinger band measurement of standard deviation. Low is used for entry conditions.
//extern double BollingerWidthHigh=75;              // Bollinger band measurement of standard deviation. High is used for exit conditions.
extern double Lots = 1;                           // standard lot size. 
extern bool Turnon = true;                        // Turns expert on, change to false and no trades will take place even if expert is enabled.

//+---------------------------------------------------+
//|General controls                                   |
//+---------------------------------------------------+

string OrderText = "";
double lotMM;
int TradesInThisSymbol;
int cnt=0, total;
datetime LastTime;
double Sl;
double Tr;
int ticket;
int trstop = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {
   int handle, err;
   
    string filename=Symbol()+TimeToStr(CurTime(),TIME_DATE) + ".txt";
    string filename1=Symbol()+TimeToStr(CurTime(),TIME_DATE) + ".txt";
    
   
//---- 
    if (Debug)
    {
      GlobalVariableSet("MyHandle",0);
      if (!GlobalVariableCheck("MyHandle"))
      {
         err = GetLastError();
         Print("Error creating Global Variable MyHandle: (" + err + ") " + ErrorDescription(err));
         return(0); 
      }
      handle = FileOpen(filename,FILE_CSV|FILE_WRITE,"\t");
      GlobalVariableSet("MyHandle",handle); 
    }
    if (Debug1)
    {
      GlobalVariableSet("MyHandle1",0);
      if (!GlobalVariableCheck("MyHandle1"))
      {
         err = GetLastError();
         Print("Error creating Global Variable MyHandle1: (" + err + ") " + ErrorDescription(err));
         return(0); 
      }
      handle = FileOpen(filename1,FILE_CSV|FILE_WRITE,"\t");
      GlobalVariableSet("MyHandle1",handle); 
    }
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {
     int handle;
 
    if (Debug)
    {
      if (GlobalVariableCheck("MyHandle"))
      {
        handle = GlobalVariableGet("MyHandle");
        FileFlush(handle);
        FileClose(handle);
        GlobalVariableDel("MyHandle");
      }  
    }
    
    if (Debug1)
    {
      if (GlobalVariableCheck("MyHandle1"))
      {
        handle = GlobalVariableGet("MyHandle1");
        FileFlush(handle);
        FileClose(handle);
        GlobalVariableDel("MyHandle1");
      }  
    }
   return(0);
  }

//+------------------------------------------------------------------+
//| Write - writes string to debug file                              |
//+------------------------------------------------------------------+

int Write(string str)
{
   int handle;
  
  if (Debug)
   {
   if (GlobalVariableCheck("MyHandle"))
      {
      handle = GlobalVariableGet("MyHandle");
      FileWrite(handle,str,"\r\n");
      } 
   }
  if (Debug1)
   {
   if (GlobalVariableCheck("MyHandle1"))
      {
      handle = GlobalVariableGet("MyHandle1");
      FileWrite(handle,str,"\r\n");
      } 
   }
 
  
}

//+------------------------------------------------------------------+
//| DetermineJuiceLevel                                              |
//|                                                                  |
//+------------------------------------------------------------------+
bool CheckJuiceEntry()
{
double level;
int shift;

//{ delete this line

// In the following Symbol need to be Symbol() and Period needs to be Period()
// Also all PERIOD_xx are integers not strings.


   if(Symbol()=="EURJPY") 
      {if (Period()==PERIOD_M15){ 
         level=760;
         shift=7;}
       if (Period()==PERIOD_M30){
         level=0;
         shift=7;}
       if (Period()==PERIOD_H1){
         level=0;
         shift=7;}
		 else {
         Comment("unexpected Time Frame EURJPY");
// you are returning an integer while function type is bool, also : at end of line instead of ;
// Same changes made below
//        return (0):
         return(false);
		   }
	   } 
	else if(Symbol()=="EURUSD") 
	  {if (Period()==PERIOD_M15){ 
         level=.0006;
         shift=7;}
       if (Period()==PERIOD_M30){
         level=.0007;
         shift=7;}
       if (Period()==PERIOD_H1){
         level=.0008;
         shift=7;}
		 else {
         Comment("unexpected Time Frame EURUSD");
         return(false);
		   }
	
	  } 
	else if(Symbol()=="GBPUSD") 
	  {if (Period()==PERIOD_M15){ 
         level=.0006;
         shift=7;}
       if (Period()==PERIOD_M30){
         level=.0007;
         shift=7;}
       if (Period()==PERIOD_H1){
         level=.0008;
         shift=7;}
		 else {
         Comment("unexpected Time Frame GBPUSD");
         return(false);
		   }
	
	  } 
	else if(Symbol()=="USDCHF") 
	  {if (Period()==PERIOD_M15){ 
         level=.0006;
         shift=7;}
       if (Period()==PERIOD_M30){
         level=.0007;
         shift=7;}
       if (Period()==PERIOD_H1){
         level=.0008;
         shift=7;}
       else {
         Comment("unexpected Time Frame USDCHF");
         return(false);
		   }
		
	  } 
	else if(Symbol()=="USDJPY") 
	  {if (Period()==PERIOD_M15){ 
         level=1500;
         shift=7;}
       if (Period()==PERIOD_M30){
         level=1500;
         shift=7;}
       if (Period()==PERIOD_H1){
         level=1500;
         shift=7;}
       else {
         Comment("unexpected Time Frame USDJPY");
         return(false);
		   }
	  } 
	else {
		Comment("unexpected Symbol");
         return(false);
	}





   double osma= 0;

   osma= iStdDev(NULL,0, 0, MODE_EMA, 0, PRICE_CLOSE,shift);
// I now use osma > level*Point
   if (osma>level)
   {
     if (Debug)
      {
      Print("Juice is ", osma);
      Write(" Juice is " + osma);
      }
     return(true);
   }
   return (false); // Juice not large enough to trade
}
  
  
//+-------------------------------------------------------------------------------------------+
//| Exit Strategies                                                                           |
//|      One or more exit strategies can be choosen to exit                                   |
//|       the trade. If Test for exit condition is set to false                               |
//|       for any exit condition, that condition will be set to                               |
//|       1 and not affect any combinations of other exit strategies.                         |
//|       Add to ExitConditionsLong to compare with ExitCntLong                               |
//|       for exit of trade.                                                                  |
//|       Add to ExitConditionsShort to compare with ExitCntShort                             |
//|       for exit of trade.                                                                  |
//+-------------------------------------------------------------------------------------------+
  
  
bool CheckMAExit(string type, int which)
{
   double MA0;
   double MA11, MA11Previous1;
   double MA12, MA12Previous1;
   double MA13, MA13Previous1;
   double MA14, MA14Previous1;
   double MA15, MA15Previous1;
   double MA1Angle, MA1AnglePrevious1, MA1AnglePrevious2;
//+------------------------------------------------------------------+
//| Calculate moving averages                                        |
//+------------------------------------------------------------------+

     MA0=iMA(NULL, 0, MA11PeriodExit, 0, MODE_EMA, PRICE_WEIGHTED, 0);
     MA11=iMA(NULL, 0, MA11PeriodExit, 0, MODE_EMA, PRICE_WEIGHTED, 1);
     MA11Previous1=iMA(NULL, 0, MA11PeriodExit, 0, MODE_EMA, PRICE_WEIGHTED, 2);
     MA12=iMA(NULL, 0, MA12PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
     MA12Previous1=iMA(NULL, 0, MA12PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 2); 
     MA13=iMA(NULL, 0, MA13PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
     MA13Previous1=iMA(NULL, 0, MA13PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//   MA14=iMA(NULL, 0, MA14PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
//   MA14Previous1=iMA(NULL, 0, MA14PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//   MA15=iMA(NULL, 0, MA15PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
//   MA15Previous1=iMA(NULL, 0, MA15PeriodExit, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//   MA1Angle=iMA(NULL, 0, MA1PeriodAngle, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
//   MA1AnglePrevious1=iMA(NULL, 0, MA1PeriodAngle, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//   MA1AnglePrevious2=iMA(NULL, 0, MA1PeriodAngle, 0, MODE_LWMA, PRICE_WEIGHTED, 3);

// The number indicating which="xy"  where,
// x= the number of values used in the condition.
// y= the number of conditions checked for.
          

if (Debug1)
   {
//     Print(Symbol()+" MA11Period "+MA11PeriodExit+" MA11="+MA11);
     Write(Symbol()+" MA11Period "+MA11PeriodExit+" MA11="+MA11);
//     Print(Symbol()+" MA12Period "+MA12PeriodExit+" MA12="+MA12);
     Write(Symbol()+" MA12Period "+MA12PeriodExit+" MA12="+MA12);
//     Print(Symbol()+" MA13Period "+MA13PeriodExit+" MA13="+MA13);
     Write(Symbol()+" MA13Period "+MA13PeriodExit+" MA13="+MA13);
//     Print(Symbol()+" MA14Period "+MA14PeriodExit+" MA14="+MA14);
//   Write(Symbol()+" MA14Period "+MA14PeriodExit+" MA14="+MA14);
//     Print(Symbol()+" MA15Period "+MA15PeriodExit+" MA15="+MA15);
//   Write(Symbol()+" MA15Period "+MA15PeriodExit+" MA15="+MA15);
//     Print(Symbol()+" MA1PeriodAngle "+MA1PeriodAngle+" MA1Angle="+MA1Angle);
//   Write(Symbol()+" MA1PeriodAngle "+MA1PeriodAngle+" MA1Angle="+MA1Angle);
//     Print(Symbol()+" MA1PeriodAnglePrevious1 "+MA1AnglePrevious1);
//   Write(Symbol()+" MA1PeriodAnglePrevious1 "+MA1AnglePrevious1);
//     Print(Symbol()+" MA1PeriodAnglePrevious2 "+MA1AnglePrevious2);
//   Write(Symbol()+" MA1PeriodAnglePrevious2 "+MA1AnglePrevious2);
   }

     if(type=="BUY")
       {
                   
         if (which == 21)
            {
            if (MA11<MA12)    //Two MA Cross met for exit long.
               return(true);
            }
                     
       }
     
     if (type=="SELL")
       {                 
         if (which == 21)
            {
            if (MA11>MA12)          //Single MA Cross met for exit short.
               return(true);
            }      
       }
     
     return(false);
}




bool CheckExitCondition(string TradeType)
{
   bool YesClose;
   YesClose = false;
   



if (TradeType == "BUY")
   {
   
//Single period trigger MA change with CCI and RSI multi-period angle.

   if (CheckMAExit("BUY",21))
      {
       if (Debug)
          {
           Print("Exit long. MA=21");
           Write("Exit long. MA=21");
          }
         YesClose=true;
       }
              
// Add other exit trategies here for long

   } //Return BUY exit routine
   
if (TradeType == "SELL")
   {
     
// Check for 4 moving averages all crossing down.
      
    if (CheckMAExit("SELL",21))
       {
        if (Debug)
           {
            Print("Exit short. MA=21");
            Write("Exit short. MA=21");
           }
          YesClose=true;
       }        

     }  //Return SELL exit routine
     
//+------------------------------------------------------------------+
//| Friday Exits                                                     |
//+------------------------------------------------------------------+

     if(DayOfWeek()==5 && Hour()>=20) YesClose = true;

     return (YesClose);
}  //Return exit conditions routine

//+-------------------------------------------------------------------------------------------+
//| Entrance Strategies                                                                       |
//|      One or more entrance strategies can be choosen to enter                              |
//|       the trade. If Test for entrance condition is set to false                           |
//|       for any entrance condition, that condition will effect                              |
//|       any combinations of other entrance strategies.                                      |
//|      If no entrance strategy is choosen, an error will come back                          |
//|       NO ENTRANCE CONDITION CHOOSEN, TRADING NOT ALLOWED                                  |
//+-------------------------------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Moving average cross for entrance.                               |
//|   If Test MA Cross is false, exit value will equal 1 for EntryCnt|
//|      Long and 1 for EntryCnt Short to allow other exit           |
//|      strategies to function.                                     |
//|   If fast MA crosses below slow MA on BUY, returns 1.            |
//|   If fast MA crosses above slow MA on SELL, returns 1.           |
//|                                                                  |
//+------------------------------------------------------------------+


bool CheckMAEntry(string type, int which)
{
   double MA0;
   double MA1, MA1Previous, MA1Previous2, MA1Previous3, MA1Previous4;
   double MA2, MA2Previous;
   double MA3, MA3Previous;
   double MA4, MA4Previous;
   double MA5, MA5Previous;
   double MA1Angle, MA1AnglePrevious1, MA1AnglePrevious2;

  MA0=iMA(NULL, 0, MA1PeriodEntry, 0, MODE_EMA, PRICE_WEIGHTED, 0);
  MA1=iMA(NULL, 0, MA1PeriodEntry, 0, MODE_EMA, PRICE_WEIGHTED, 1);
  MA1Previous=iMA(NULL, 0, MA1PeriodEntry, 0, MODE_EMA, PRICE_WEIGHTED, 2);
  MA1Previous2=iMA(NULL, 0, MA1PeriodEntry, 0, MODE_EMA, PRICE_WEIGHTED, 3);
  MA1Previous3=iMA(NULL, 0, MA1PeriodEntry, 0, MODE_EMA, PRICE_WEIGHTED, 4);
  MA1Previous4=iMA(NULL, 0, MA1PeriodEntry, 0, MODE_EMA, PRICE_WEIGHTED, 5);
  MA2=iMA(NULL, 0, MA2PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
  MA2Previous=iMA(NULL, 0, MA2PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
  MA3=iMA(NULL, 0, MA3PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
  MA3Previous=iMA(NULL, 0, MA3PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//  MA4=iMA(NULL, 0, MA4PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
//  MA4Previous=iMA(NULL, 0, MA4PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//  MA5=iMA(NULL, 0, MA5PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
//  MA5Previous=iMA(NULL, 0, MA5PeriodEntry, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//  MA1Angle=iMA(NULL, 0, MA1PeriodAngle, 0, MODE_LWMA, PRICE_WEIGHTED, 1);
//  MA1AnglePrevious1=iMA(NULL, 0, MA1PeriodAngle, 0, MODE_LWMA, PRICE_WEIGHTED, 2);
//  MA1AnglePrevious2=iMA(NULL, 0, MA1PeriodAngle, 0, MODE_LWMA, PRICE_WEIGHTED, 3);    

// The number indicating which="xy"  where,
// x= the number of values used in the condition.
// y= the number of conditions checked for.


if (Debug1)
   {
//     Print(Symbol()+" MA1Period "+MA1PeriodEntry+" MA1="+MA1);
     Write(Symbol()+" MA1Period "+MA1PeriodEntry+" MA1="+MA1);
//     Print(Symbol()+" MA2Period "+MA2PeriodEntry+" MA2="+MA2);
     Write(Symbol()+" MA2Period "+MA2PeriodEntry+" MA2="+MA2);
//     Print(Symbol()+" MA3Period "+MA3PeriodEntry+" MA3="+MA3);
     Write(Symbol()+" MA3Period "+MA3PeriodEntry+" MA3="+MA3);
//     Print(Symbol()+" MA4Period "+MA4PeriodEntry+" MA4="+MA4);
//     Write(Symbol()+" MA4Period "+MA4PeriodEntry+" MA4="+MA4);
//     Print(Symbol()+" MA5Period "+MA5PeriodEntry+" MA5="+MA5);
//     Write(Symbol()+" MA5Period "+MA5PeriodEntry+" MA5="+MA5);
//     Print(Symbol()+" MA1PeriodAngle "+MA1PeriodAngle+" MA1Angle="+MA1Angle);
//     Write(Symbol()+" MA1PeriodAngle "+MA1PeriodAngle+" MA1Angle="+MA1Angle);
//     Print(Symbol()+" MA1PeriodAnglePrevious1 "+MA1AnglePrevious1);
//     Write(Symbol()+" MA1PeriodAnglePrevious1 "+MA1AnglePrevious1);
//     Print(Symbol()+" MA1PeriodAnglePrevious2 "+MA1AnglePrevious2);
//     Write(Symbol()+" MA1PeriodAnglePrevious2 "+MA1AnglePrevious2);
   }

if (type == "BUY")  
  {       
         if (which == 21)
            {
            if (MA1>MA2)    //Two MA Cross met for entrance long.
               return(true);
            }
            
         if (which == 99)
            {
            if (MA1>MA5)        //Current bar MA for market direction.
               return(true);
            }      
             
   }
     
     if (type=="SELL")
       {         
         if (which == 21)
            {
            if (MA1<MA2)          //Single MA Cross met for entrance short.
               return(true);
            }
                       
         if (which == 99)
            {
            if (MA1<MA5)      //Current bar MA for market direction.
               return(true);
            }   
            
         
      }
     
     return(false);
}

//+------------------------------------------------------------------+
//| Bollinger band squeeze.                                          |
//|   If the width of the Bollinger Bands is too narrow no trades    |
//|   are allowed so return false                                    |
//|   Otherwise return true                                          |
//+------------------------------------------------------------------+

bool CheckBBEntry()
{
   double BB1Lower;
   double BB1Upper;
   double BB1Width;
   


//+------------------------------------------------------------------+
//| Calculate Bollinger Band width                                   |
//+------------------------------------------------------------------+
  
  BB1Lower=iBands(NULL, PERIOD_M5, BollingerPeriod1, BollingerStdDev1, 0, PRICE_CLOSE, MODE_LOWER, 1);
  BB1Upper=iBands(NULL, PERIOD_M5, BollingerPeriod1, BollingerStdDev1, 0, PRICE_CLOSE, MODE_UPPER, 1);
  BB1Width=BB1Upper-BB1Lower;

   if (StringSubstr(Symbol(),3,3)=="JPY")
      {
      BB1Width=BB1Width*100;
      }
      else
      {
      BB1Width=BB1Width*10000;
      }
  
   if (Debug)
   {
     Print(Symbol()+" Bollinger width "+BB1Width);
     Write(Symbol()+" Bollinger width "+BB1Width);
   }

   Comment("Bollinger Width=",BB1Width);
 
       if (BB1Width > BollingerWidthLow)
       {
         if (Debug)
//         {
//            Print("Bollinger band width greater than narrow limit, allow trade.");
//            Write("Bollinger band width greater than narrow limit, allow trade.");
//         }
         return(true);
       }   
      return(false);
}

   
//+-------------------------------------------------------------------------------------------+
//| CheckEntryCondition                                                                       |
//| Check if any entry condition is met                                                       |
//+-------------------------------------------------------------------------------------------+

bool CheckEntryCondition(string TradeType)
{
   bool YesTrade;
      
   YesTrade = false;
  
   if (TradeType == "BUY")
      {
   
//Single period trigger MA change with CCI and RSI multi-period angle.        

      if (CheckMAEntry("BUY",21)) 
         {
         if (Debug)
            {
             Print("Enter long. MA=21");
             Write("Enter long. MA=21");
            }
          YesTrade=true;
         }      
         
        
// Add other strategies here for long entry.

   } //Return BUY enter routine.
   
if (TradeType == "SELL")
   {
     
//Single period trigger MA change with CCI and RSI multi-period angle.

      if (CheckMAEntry("SELL",21)) 
         {
         if (Debug)
            {
             Print("Enter short. MA=21");
             Write("Enter short. MA=21");
            }
          YesTrade=true;
         }
         
                  
// Add other strategies here for short entry.
       
      }  //Return SHORT enter routine.
      
    return(YesTrade);  
    
} //Return check entry condition.
          

//+-------------------------------------------------------------------------------------------+
//| expert start function                                                                     |
//+-------------------------------------------------------------------------------------------+

int start()
  {
//---- 
      
   double Min_OrderPrice;
   bool ExitBuy, ExitSell;
   int donttrade, allexit, err;
   
   trstop = 0;

	int MagicNumber = 3000 + func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period()); 

   string setup="mi_v7 " + Symbol() + "_" + func_TimeFrame_Val2String(func_TimeFrame_Const2Val(Period()));
   
//|      If no exit strategy is choosen, an error will come back     |
//|       NO EXIT CONDITION CHOOSEN, TRADING NOT ALLOWED             |

//   if ( !(TestMACrossMA4MA5ForExit || TestMACrossMA4MA5MA6ForExit ))
//   {
//    Alert("NO EXIT CONDITION CHOSEN, TRADING NOT ALLOWED");
//     return(0);
//   }

   donttrade = 0;
   
//+------------------------------------------------------------------+
//| Friday Exits                                                     |
//+------------------------------------------------------------------+

   if(DayOfWeek()==5 && Hour()>=18) donttrade=1;

   
//+------------------------------------------------------------------+
//| Open Position Controls                                           |
//+------------------------------------------------------------------+

   ExitBuy = CheckExitCondition("BUY");
   ExitSell = CheckExitCondition("SELL");
   HandleOpenPositions(MagicNumber, ExitBuy, ExitSell);

// Check if any open positions were not closed

   TradesInThisSymbol = CheckOpenPositions(MagicNumber);
     


if(AccountFreeMargin() < Margincutoff) {
   return(0);}
if(TradesInThisSymbol > 0) {
   return(0);}
if(CurTime() < LastTime) {
   return(0);}
   
// Moved money management here because closed trades change account balance

if(MoneyManagement)
{
  lotMM = LotsOptimized(MagicNumber);
}
else {
  lotMM = Lots;
  if(AccountIsMini)
  {
    if (lotMM > 1.0) lotMM = lotMM / 10;
    if (lotMM < 0.1) lotMM = 0.1;
  }
   
}

// Check for Bollinger band width to allow trading
// Test width of Bollinger band for times of narrow channeling if true.
// If width of Bollinger band is to narrow, don't proceed with any other entry testing.

 if (TestBollingerWidth)
 {
    if (!CheckBBEntry()) return(0);
 }
       
 if (UseJuice)
   {
    if (!CheckJuiceEntry()) return (0);  // Check Juice filter for flat market
   }

//+------------------------------------------------------------------+
//| New Position Controls                                            |
//+------------------------------------------------------------------+
     
  OrderText = ""; //Must be blank before going into the main section

   if (CheckEntryCondition("BUY") && !CheckExitCondition("BUY") && donttrade == 0)	
	{
		OrderText = "BUY";
		if (StopLoss>0) {
		 Sl = Ask-StopLoss*Point;
		} else {
		 Sl=0;
		}
		if (TakeProfit == 0) 
		    Tr = 0;
		else
		    Tr = Ask+TakeProfit*Point;
	}

	if (CheckEntryCondition("SELL") && !CheckExitCondition("SELL") && donttrade == 0)
	{
		OrderText = "SELL";
		if (StopLoss>0) {
		 Sl = Bid+StopLoss*Point;
		} else {
		 Sl = 0;
		}
		if (TakeProfit == 0) 
		    Tr = 0;
		else
		    Tr = Bid-TakeProfit*Point;
	}
   if(OrderText != "" && trstop == 0 && TradesInThisSymbol <= 0 && Turnon) 
   {

	   LastTime = CurTime();
           if(OrderText == "BUY")
           {
               Min_OrderPrice=MinOrderPrice(OP_BUY, MagicNumber);
               if (Min_OrderPrice>0 && Min_OrderPrice<=Ask*1.05) {
                  Print("Buy too expensive => MinOrderPrice= " + Min_OrderPrice + "  Ask=" + Ask);
               } else {
                  Print(Symbol() + " OP_BUY " + lotMM + " " + Ask + " " + Sl + " " + Tr);
	              ticket = OrderSendExtended(Symbol(),OP_BUY,lotMM,Ask,3,Sl,Tr,setup,MagicNumber,0,Green);
                  if (!IsTesting()) PlaySound("expert.wav");
	              LastTime += 12;
                 if(ticket<=0) {
                     err = GetLastError();
                     Print("Error opening BUY order [" + setup + "]: (" + err + ") " + ErrorDescription(err)); 
                     if (!IsTesting()) PlaySound("alert2.wav");
                 }
                 return(0);
               }
           }
            else if(OrderText == "SELL")
            {
               Min_OrderPrice=MinOrderPrice(OP_SELL, MagicNumber);
         
               if (Min_OrderPrice>0 && Min_OrderPrice>=Bid) {
                  Print("Sell too expensive MinOrderPrice= " + Min_OrderPrice + "  Bid=" + Bid);
               } else {
                  Print(Symbol() + " OP_SELL " + lotMM + " " + Bid + " " + Sl + " " + Tr);
                  ticket = OrderSendExtended(Symbol(),OP_SELL,lotMM,Bid,3,Sl,Tr,setup,MagicNumber,0,Red);
                  if (!IsTesting()) PlaySound("expert.wav");
                  LastTime += 12;
                 if(ticket<=0) {
                     err = GetLastError();
                     Print("Error opening Sell order [" + setup + "]: (" + err + ") " + ErrorDescription(err)); 
                     if (!IsTesting()) PlaySound("alert2.wav");
                 }
                  return(0);
               }
            }
      return(0);
   }
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Check Open Position Controls                                     |
//+------------------------------------------------------------------+
  
int CheckOpenPositions(int MagicNumbers)
{
   int cnt, total, NumPositions;
   int NumBuyTrades, NumSellTrades;   // Number of buy and sell trades in this symbol
   
   NumBuyTrades = 0;
   NumSellTrades = 0;
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      if ( OrderSelect (cnt, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumbers)  continue;
      
      if((OrderType() == OP_BUY || OrderType() == OP_BUYSTOP) && (OrderSymbol()==Symbol()))
          {
             NumBuyTrades++;
          }
             
      if((OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) && (OrderSymbol()==Symbol()))
          {
             NumSellTrades++;
          }
             
     }
     NumPositions = NumBuyTrades + NumSellTrades;
     return (NumPositions);
  }


//+------------------------------------------------------------------+
//| Handle Open Positions                                            |
//| Check if any open positions need to be closed or modified        |
//| Three attempts are made to close or modify                       |
//+------------------------------------------------------------------+
int HandleOpenPositions(int MagicNum, bool BuyExit, bool SellExit)
{
   int cnt, total;
   int CloseCnt, err;
   
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      if ( OrderSelect (cnt, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNum)  continue;
      
      if((OrderType() == OP_BUY || OrderType() == OP_BUYSTOP) && (OrderSymbol()==Symbol()))
          {
            
            if (BuyExit)
            {
   // try to close 3 Times
      
              CloseCnt = 0;
              while (CloseCnt < 3)
              {
                if (!OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet))
                {
                 err=GetLastError();
                 Print(CloseCnt," Error closing order : (", err , ") " + ErrorDescription(err));
                 if (err > 0) CloseCnt++;
                }
                else
                {
                 CloseCnt = 3;
                }
               }
               return (0);
             }
                      // check for stop
             if(Stop>0)  
             {                 
               if(Bid-OrderOpenPrice()>=Point*Stop)
               {
                   OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                   return(0);
               }
             }
             else
             {
              if(TrailingStop>0) 
               {                
                 if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                  {
                     CloseCnt=0;
                     while (CloseCnt < 3)
                     {
                     if (!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Aqua))
                     {
                        err=GetLastError();
                        if (err>0) CloseCnt++;
                     }
                     else CloseCnt = 3;
                     }
                  }
                 }
              }
              return(0);
             }
          }

      if((OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) && (OrderSymbol()==Symbol()))
          {
            if (SellExit)
            {
            
   // try to close 3 Times
      
               CloseCnt = 0;
               while (CloseCnt < 3)
               {
                 if (!OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet))
                 {
                  err=GetLastError();
                  Print(CloseCnt," Error closing order : ",cnt," (", err , ") " + ErrorDescription(err));
                  if (err > 0) CloseCnt++;
                 }
                 else CloseCnt = 3;
               }
               return(0);
             }
        // check for stop
             if(Stop>0)  
             {                 
                if(OrderOpenPrice()-Ask>=Point*Stop)
                {
                   OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
                   return(0);
                }
             }
           
   // try to modify 3 Times
      
             if(TrailingStop>0)  
             {                
                if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                {
                   if(OrderStopLoss()==0.0 || OrderStopLoss()>(Ask+Point*TrailingStop))
                   {
                     CloseCnt = 0;
                     while (CloseCnt < 3)
                     {
                       if (!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Aqua))
                       {
                         err=GetLastError();
                         if (err > 0) CloseCnt++;
                       }
                       else CloseCnt = 3;
                     }
                   }
                 }
                 return(0);
              }
         }
    }
}


//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+

double LotsOptimized(int Mnr)
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int    tolosses=0;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*Riskpercent/10000)/10,1);
   
//+------------------------------------------------------------------+  
//|  Calculate number of losses orders without a break               |
//+------------------------------------------------------------------+

   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL || OrderMagicNumber()!=Mnr) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      for(i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(TimeDay(OrderCloseTime()) != TimeDay(CurTime())) continue;
         //----
         if(OrderProfit()<0) tolosses++;
        }
        if (tolosses >= MaximumLosses) trstop=1;
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
     
  // Check if mini or standard Account

  if(AccountIsMini)
  { 
      lot = MathFloor(lot);
      lot = lot / 10;
// Use at least 1 mini lot
      if(lot<0.1) lot=0.1;
  }else
  {
    if (lot < 1.0) lot = 1.0;
    if (lot > 100) lot = 100;
  }         

   return(lot);
  } 

//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                               |
//+------------------------------------------------------------------+

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}

//+------------------------------------------------------------------+
//| Time frame string appropriation  function                               |
//+------------------------------------------------------------------+

string func_TimeFrame_Val2String(int Value ) {
   switch(Value) {
      case 1:  // M1
         return("PERIOD_M1");
      case 2:  // M1
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}

int func_Symbol2Val(string symbol) {
	if(symbol=="AUDCAD") {
		return(1);
	} else if(symbol=="AUDJPY") {
		return(2);
	} else if(symbol=="AUDNZD") {
		return(3);
	} else if(symbol=="AUDUSD") {
		return(4);
	} else if(symbol=="CHFJPY") {
		return(5);
	} else if(symbol=="EURAUD") {
		return(6);
	} else if(symbol=="EURCAD") {
		return(7);
	} else if(symbol=="EURCHF") {
		return(8);
	} else if(symbol=="EURGBP") {
		return(9);
	} else if(symbol=="EURJPY") {
		return(10);
	} else if(symbol=="EURUSD") {
		return(11);
	} else if(symbol=="GBPCHF") {
		return(12);
	} else if(symbol=="GBPJPY") {
		return(13);
	} else if(symbol=="GBPUSD") {
		return(14);
	} else if(symbol=="NZDUSD") {
		return(15);
	} else if(symbol=="USDCAD") {
		return(16);
	} else if(symbol=="USDCHF") {
		return(17);
	} else if(symbol=="USDJPY") {
		return(18);
	} else {
		Comment("unexpected Symbol");
		return(0);
	}
}

//+------------------------------------------------------------------+
//| Average price efficiency  function                               |
//+------------------------------------------------------------------+

double MinOrderPrice(int OType, int OMagicNumber) {
double MinPrice;

   if (OrderType()==OP_BUY) {
      MinPrice=1000000;
   } else {
      MinPrice=0;
   }
 
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      
      if(OrderType()==OType && OrderSymbol()==Symbol() && OrderMagicNumber()==OMagicNumber) {
         if (OrderType()==OP_BUY) {
            if (OrderOpenPrice()<MinPrice) {
               MinPrice=OrderOpenPrice();
            }
         } else {
            if (OrderOpenPrice()>MinPrice) {
               MinPrice=OrderOpenPrice();
            }
         }
      }
   }
   if (MinPrice==1000000) MinPrice=0;
   return(MinPrice);
   
}

int OrderSendExtended(string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment, int magic, datetime expiration=0, color arrow_color=CLR_NONE) {
   datetime OldCurTime;
   int timeout=30;

   OldCurTime=CurTime();
   while (GlobalVariableCheck("InTrade") && !IsTradeAllowed()) {
      if(OldCurTime+timeout<=CurTime()) {
         Print("Error in OrderSendExtended(): Timeout encountered");
         return(0); 
      }
      Sleep(1000);
   }
     
   GlobalVariableSet("InTrade", CurTime());  // set lock indicator
   ticket = OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color);
   GlobalVariableDel("InTrade");   // clear lock indicator
   return(ticket);
}